<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getPackageInfo StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getPackageInfo
 * @subpackage Structs
 */
class GetPackageInfo extends AbstractStructBase
{
    /**
     * The pack
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pack;
    /**
     * Constructor method for getPackageInfo
     * @uses GetPackageInfo::setPack()
     * @param string $pack
     */
    public function __construct($pack = null)
    {
        $this
            ->setPack($pack);
    }
    /**
     * Get pack value
     * @return string|null
     */
    public function getPack()
    {
        return $this->pack;
    }
    /**
     * Set pack value
     * @param string $pack
     * @return \StructType\GetPackageInfo
     */
    public function setPack($pack = null)
    {
        // validation for constraint: string
        if (!is_null($pack) && !is_string($pack)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pack)), __LINE__);
        }
        $this->pack = $pack;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPackageInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
