<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for issue StructType
 * Meta informations extracted from the WSDL
 * - type: tns:issue
 * @subpackage Structs
 */
class Issue extends AbstractStructBase
{
    /**
     * The quotation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Quotation
     */
    public $quotation;
    /**
     * Constructor method for issue
     * @uses Issue::setQuotation()
     * @param \StructType\Quotation $quotation
     */
    public function __construct(\StructType\Quotation $quotation = null)
    {
        $this
            ->setQuotation($quotation);
    }
    /**
     * Get quotation value
     * @return \StructType\Quotation|null
     */
    public function getQuotation()
    {
        return $this->quotation;
    }
    /**
     * Set quotation value
     * @param \StructType\Quotation $quotation
     * @return \StructType\Issue
     */
    public function setQuotation(\StructType\Quotation $quotation = null)
    {
        $this->quotation = $quotation;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Issue
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
