<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for listPackagesInfoResponse StructType
 * Meta informations extracted from the WSDL
 * - type: tns:listPackagesInfoResponse
 * @subpackage Structs
 */
class ListPackagesInfoResponse extends AbstractStructBase
{
    /**
     * The return
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PackInfo[]
     */
    public $return;
    /**
     * Constructor method for listPackagesInfoResponse
     * @uses ListPackagesInfoResponse::setReturn()
     * @param \StructType\PackInfo[] $return
     */
    public function __construct(array $return = array())
    {
        $this
            ->setReturn($return);
    }
    /**
     * Get return value
     * @return \StructType\PackInfo[]|null
     */
    public function getReturn()
    {
        return $this->return;
    }
    /**
     * Set return value
     * @throws \InvalidArgumentException
     * @param \StructType\PackInfo[] $return
     * @return \StructType\ListPackagesInfoResponse
     */
    public function setReturn(array $return = array())
    {
        foreach ($return as $listPackagesInfoResponseReturnItem) {
            // validation for constraint: itemType
            if (!$listPackagesInfoResponseReturnItem instanceof \StructType\PackInfo) {
                throw new \InvalidArgumentException(sprintf('The return property can only contain items of \StructType\PackInfo, "%s" given', is_object($listPackagesInfoResponseReturnItem) ? get_class($listPackagesInfoResponseReturnItem) : gettype($listPackagesInfoResponseReturnItem)), __LINE__);
            }
        }
        $this->return = $return;
        return $this;
    }
    /**
     * Add item to return value
     * @throws \InvalidArgumentException
     * @param \StructType\PackInfo $item
     * @return \StructType\ListPackagesInfoResponse
     */
    public function addToReturn(\StructType\PackInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PackInfo) {
            throw new \InvalidArgumentException(sprintf('The return property can only contain items of \StructType\PackInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->return[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListPackagesInfoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
