<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MotorQuotation StructType
 * @subpackage Structs
 */
class MotorQuotation extends Quotation
{
    /**
     * The motorInsurable
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MotorInsurable
     */
    public $motorInsurable;
    /**
     * Constructor method for MotorQuotation
     * @uses MotorQuotation::setMotorInsurable()
     * @param \StructType\MotorInsurable $motorInsurable
     */
    public function __construct(\StructType\MotorInsurable $motorInsurable = null)
    {
        $this
            ->setMotorInsurable($motorInsurable);
    }
    /**
     * Get motorInsurable value
     * @return \StructType\MotorInsurable|null
     */
    public function getMotorInsurable()
    {
        return $this->motorInsurable;
    }
    /**
     * Set motorInsurable value
     * @param \StructType\MotorInsurable $motorInsurable
     * @return \StructType\MotorQuotation
     */
    public function setMotorInsurable(\StructType\MotorInsurable $motorInsurable = null)
    {
        $this->motorInsurable = $motorInsurable;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MotorQuotation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
