<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for statusDto StructType
 * @subpackage Structs
 */
class StatusDto extends AbstractStructBase
{
    /**
     * The stage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $stage;
    /**
     * The type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * Constructor method for statusDto
     * @uses StatusDto::setStage()
     * @uses StatusDto::setType()
     * @param string $stage
     * @param string $type
     */
    public function __construct($stage = null, $type = null)
    {
        $this
            ->setStage($stage)
            ->setType($type);
    }
    /**
     * Get stage value
     * @return string|null
     */
    public function getStage()
    {
        return $this->stage;
    }
    /**
     * Set stage value
     * @param string $stage
     * @return \StructType\StatusDto
     */
    public function setStage($stage = null)
    {
        // validation for constraint: string
        if (!is_null($stage) && !is_string($stage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stage)), __LINE__);
        }
        $this->stage = $stage;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\StatusDto
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StatusDto
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
